; AutoDial.asm
;
; Establishes a RAS connection between a RAS client and a RAS server.
; i.e. Dials the last phone number for the Internet Provider

      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

     include \masm32\include\windows.inc
     include \masm32\include\user32.inc
     include \masm32\include\kernel32.inc
     include \masm32\include\comdlg32.inc
     include \masm32\include\Comctl32.inc
     include \masm32\include\rasapi32.inc
      
     includelib \masm32\lib\user32.lib
     includelib \masm32\lib\kernel32.lib
     includelib \masm32\lib\comdlg32.lib
     includelib \masm32\lib\Comctl32.lib
     includelib \masm32\lib\rasapi32.lib

    WinMain PROTO

    RASENTRYNAME5A STRUCT
        dwSize dd ?
        szEntryName db 260 dup(?)
        dwFlags dd ?
        szPhonebookPath db 264 dup(?)
    RASENTRYNAME5A ENDS

    RASENTRYNAME5 EQU <RASENTRYNAME5A>

    RASDIALPARAMS4A STRUCT
        dwSize dd ?
        szEntryName db 101h dup(?)
        szPhoneNumber db 81h dup(?)
        szCallbackNumber db 81h dup(?)
        szUserName db 101h dup(?)
        szPassword db 101h dup(?)
        szDomain db 13h dup(?)

        dwSubEntry dd ?
        dwCallbackId dd ?
    RASDIALPARAMS4A ENDS

    RASDIALPARAMS4 EQU <RASDIALPARAMS4A>

    .data

    szApp db  "AutoDial",0
    szSucc db "Connection has been successful !",0

    .code

start:

    invoke WinMain

    invoke ExitProcess,eax

WinMain proc

 LOCAL lpRasEntryName    :DWORD
 LOCAL dwCb   :DWORD
 LOCAL dwEntries  :DWORD
 LOCAL rp   :RASDIALPARAMS4
 LOCAL fPass   :BOOL
 LOCAL hConn   :DWORD

 mov dwCb, sizeof RASENTRYNAME5
 mov lpRasEntryName, 0

AllocateRasEntryNameLoop:

      cmp lpRasEntryName, 0
      je AllocateRasEntryName
      invoke GetProcessHeap
      invoke HeapFree, eax, 0, lpRasEntryName

AllocateRasEntryName:
      invoke GetProcessHeap
      invoke HeapAlloc, eax, 0, dwCb
      cmp eax, 0
      je RetFail
     
      mov lpRasEntryName, eax
      invoke RtlZeroMemory, lpRasEntryName, dwCb
      mov ebx, sizeof RASENTRYNAME5
      mov eax, lpRasEntryName
      mov (RASENTRYNAME5 PTR [eax]).dwSize, ebx

      invoke RasEnumEntries, NULL, NULL, lpRasEntryName, ADDR dwCb, ADDR dwEntries
      cmp eax, 278h
      je AllocateRasEntryNameLoop

      cmp eax, 0
      jne RetFail

      mov dwCb, sizeof RASDIALPARAMS4

      invoke RtlZeroMemory, ADDR rp, dwCb     
      mov eax, dwCb
      mov rp.dwSize, eax

      mov eax, lpRasEntryName

 invoke lstrcpy, ADDR rp.szEntryName, ADDR (RASENTRYNAME5 PTR [eax]).szEntryName

 invoke RasGetEntryDialParams, NULL, ADDR rp, ADDR fPass
      cmp eax, 0
      jne RetFail
      mov hConn, 0

      invoke RasDial, NULL, NULL, ADDR rp, 0, NULL, ADDR hConn
      cmp eax, 0
      jne RetFail
      ;invoke MessageBox,0,addr szSucc,addr szApp,MB_OK

RetFail:

      cmp lpRasEntryName, 0
      je AllocateRasEntryName
      invoke GetProcessHeap
      invoke HeapFree, eax, 0, lpRasEntryName

      ret

WinMain endp

end start